/* encoding = CP932 */
//======================================================================================
//======================================================================================
//
//
//			Ctj
//
//
//======================================================================================
//======================================================================================


//======================================================================================
//	include
//======================================================================================
#include "LifeParts.h"
#include "Application.h"

//======================================================================================
//
//	RXgN^
//
//======================================================================================
CLIFEPARTS::CLIFEPARTS( float x, float y, D3DCOLOR color ) : CSPRITE( SORT_NULL )
{
	yaw = RAND_PAI;
	roll = RAND_PAI;
	pitch = RAND_PAI;
	Color = color & 0x00FFFFFF;
	Px = x;
	Py = y;
	long speed = RAND( 0<<16, 3<<16 );
	long angle = RAND( 0, 4095 );
	x1 = F(LunaMath::Sin( angle, speed )) / 65536.0f;
	y1 = F(LunaMath::Cos( angle, speed )) / 65536.0f;
	Alpha = 255;
}

//======================================================================================
//
//	
//
//======================================================================================
bool CLIFEPARTS::Action( void )
{
	Px += x1;
	Py += y1;
	yaw += 0.05f;
	roll += 0.07f;
	pitch += 0.09f;
	Scale = LunaMath::AddSpeed(   5L, 15L, 50, Time );
	Alpha = LunaMath::AddSpeed( 255L,  0L, 50, Time );

	CApplication::AddEffect( this );

	return ( ++Time == 50 );
}

//======================================================================================
//
//	`
//
//======================================================================================
void CLIFEPARTS::Draw( void )
{
	LunaEffect::TriangleRotate( (long)Px, (long)Py, Scale, yaw, pitch, roll, Color|(Alpha<<24), true );
}