/* encoding = CP932 */


//=====================================================================
// INCLDUE
//=====================================================================
#include "Application.h"
#include "Io.h"
#include "BossLaser.h"

//=====================================================================
// STRUCT
//=====================================================================
// RtBO
typedef struct _CONFIGDATA
{
	unsigned char IsWindow;
	unsigned char IsFullColor;
	unsigned char IsFullColorTexture;
}
CONFIGDATA, *LPCONFIGDATA;

//=====================================================================
// GLOBAL
//=====================================================================
CList SpriteList;
LTEXTURE SubGraphic;
LSPRITE Sprite[10][2];
RECT RefreshSrc = { 0, 0, 640, 480 };
RECT RefreshDest = { 0, 0, 640, 480 };
long QuakePhase = -1;
long QuakeType = -1;
CONFIGDATA Config = { 1, 0, 0 };


//=====================================================================
//
//		ݒ
//
//=====================================================================
void Luna::SetInfo( void )
{
	FILE *fp = fopen( "config.dat", "rb" );
	if ( fp != NULL )
	{
		fread( &Config, sizeof(CONFIGDATA), 1, fp );
		fclose( fp );
	}

	Luna::SetScreenMode( 640, 480, Config.IsWindow );

	// EBhE^Cg
	//Luna::SetWindowTitle( "܂Ԃ`ނƂ股" );
	//Luna::SetWindowTitleUtf8( "\343\201\276\343\201\242\343\201\213\343\202\213\343\201\266\343\202\213\357\275\236\343\202\200\343\201\210\343\201\217\343\201\231\343\201\250\343\202\212\343\201\203\343\202\200" );
Luna::SetWindowTitleUtf8( "MBX-Magical Broom eXtreme " );

	// XN[[h̐ݒ
	if ( !Config.IsWindow )
	{
		// }EX̕\ݒ
		Luna::SetShowMouse( FALSE );
		// IMEזȂ̂ŏ
		LunaSystem::SetShowIME( FALSE );
	}
	else
	{
		// FPS\ݒ
		Luna::SetShowFPS( true );
	}

	// tJ[
	if ( Config.IsFullColor ) Luna3D::EnableFullColorMode();

	// tJ[eNX`
	if ( Config.IsFullColorTexture ) Luna3D::EnableFullColorTexture();

	// Ot@C
	Luna::SetLogFile( "Boot_Log.txt" );

	// FPSݒ
	Luna::SetFPS( 50 );

	// gpDirectX
	Luna::SetUseOption( USE_DIRECT3D | USE_DIRECTSOUND | USE_DIRECTINPUT );
}

//=====================================================================
//
//		
//
//=====================================================================
void Luna::Init( void )
{
	SpriteList.Init();

	// OtBbNǂݍ
	LTEXTURE Graphic = LunaTexture::LoadLAG( "graphic.lag", "graphic", TRUE );
	SubGraphic = LunaTexture::LoadLAG( "graphic.lag", "sub_graphic", TRUE );

	// XvCg
	for ( long i = 0; i < 10; i++ )
	{
		if ( i == 6 )
		{
			Sprite[i][0] = LunaSprite::Create( 512, Graphic, BLEND_NORMAL );
			RECT uv = { 0 };
			Sprite[i][1] = LunaSprite::CreateLaser( LASER_DIV, &uv, Graphic, BLEND_ADD );
		}
		else
		{
			Sprite[i][0] = LunaSprite::Create( 512, Graphic, BLEND_NORMAL );
			Sprite[i][1] = LunaSprite::Create( 512, Graphic, BLEND_ADD );
		}
	}

	// J
	Graphic->Release();

	// fBU
	Luna3D::SetRenderState( STATE_DITHER, ENABLE );

	// oCjAtB^
	Luna3D::SetSmoothFilter( TRUE );

	// 
	CApplication::Initialize();
}

//=====================================================================
//
//		I
//
//=====================================================================
void Luna::UnInit( void )
{
	// IMEA
	LunaSystem::SetShowIME( true );

	// I
	CApplication::UnInitialize();

	// XvCg
	for ( long i = 0; i < 8; i++ )
	{
		Sprite[i][0]->Release();
		Sprite[i][1]->Release();
	}

	SpriteList.Release();
	SubGraphic->Release();
}

//=====================================================================
//
//		C[v
//
//=====================================================================
void Luna::MainLoop( void )
{
	// L[XV
	IO::RefreshKeyState();

	// V[Ăяo
	CApplication::Main();

	// ʐU
	QuakeScreen();

	// ʍXV
	Luna3D::Refresh( &RefreshDest, &RefreshSrc );
}

//=====================================================================
//
//		ʐU
//
//=====================================================================
void QuakeScreen( void )
{
	static long Angle, Time;
	long x = 320, y = 240, scale = 0;

	switch ( QuakeType )
	{
	/////////////////////////////////////////////////////////// c
	case 0:
		switch ( QuakePhase )
		{
		case 0:
			Angle = 0;
			Time = 0;
			QuakePhase++;
			break;
		case 1:
			scale = LunaMath::FlatSpeed( 6L, 0L, 50, Time );
			y = 240 + LunaMath::Sin( Angle+=384, scale );
			if ( ++Time == 50 ) QuakePhase++;
			break;
		}
		break;
	/////////////////////////////////////////////////////////// 
	case 1:
		switch ( QuakePhase )
		{
		case 0:
			Angle = 0;
			Time = 0;
			QuakePhase++;
			break;
		case 1:
			scale = LunaMath::FlatSpeed( 8L, 0L, 50, Time );
			x = 320 + LunaMath::Sin( Angle+=384 , scale );
			if ( ++Time == 50 ) QuakePhase++;
			break;
		}
		break;
	}

	// Jݒ
	RECT src = { 0, 0, 640, 480 };
	RECT dest = { x-320, y-240, x+320, y+240 };
	SetCamera( &dest, &src );
}

//=====================================================================
//
//		ʐUݒ
//
//=====================================================================
void SetQuake( long type )
{
	QuakePhase = 0;
	QuakeType = type;
}

//=====================================================================
//
//		XVʐݒ
//
//=====================================================================
void SetCamera( RECT *dest, RECT *src )
{
	RefreshDest = *dest;
	RefreshSrc = *src;
}
